# 🔠 plugin-rename

[![npm](https://img.shields.io/npm/v/@start/plugin-rename.svg?style=flat-square)](https://www.npmjs.com/package/@start/plugin-rename) [![linux](https://img.shields.io/travis/deepsweet/start/master.svg?label=linux&style=flat-square)](https://travis-ci.org/deepsweet/start) [![windows](https://img.shields.io/appveyor/ci/deepsweet/start/master.svg?label=windows&style=flat-square)](https://ci.appveyor.com/project/deepsweet/start) [![coverage](https://img.shields.io/codecov/c/github/deepsweet/start/master.svg?style=flat-square)](https://codecov.io/github/deepsweet/start) [![deps](https://david-dm.org/deepsweet/start.svg?path=packages/plugin-rename&style=flat-square)](https://david-dm.org/deepsweet/start?path=packages/plugin-rename)

Rename files.

## Install

```sh
$ yarn add --dev @start/plugin-rename
# or
$ npm install --save-dev @start/plugin-rename
```

## Usage

### Signature

```ts
rename(callback: (file: string) => string)
```

### Example

```js
import sequence from '@start/plugin-sequence'
import find from '@start/plugin-find'
import read from '@start/plugin-read'
import babel from '@start/plugin-lib-babel'
import rename from '@start/plugin-rename'
import write from '@start/plugin-write'

const babelConfig = {
  // …
  babelrc: false,
  sourceMap: true,
}

export const task = () =>
  sequence(
    find('src/*.ts'),
    read,
    babel(babelConfig),
    rename((file) => file.replace(/\.ts$/, '.js')),
    write('build/')
  )
```
